/*
 * Copyright 2005 Geert Bevin <gbevin[remove] at uwyn dot com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 *
 * $Id: Zipcode.java 2566 2005-10-07 14:47:29Z gbevin $
 */
package com.yourcompany.rife.elements;

import com.uwyn.rife.engine.Element;
import java.util.HashMap;
import java.util.Map;

public class Zipcode extends Element
{
	private final static Map<Integer, String[]> ZIPCODES =
		new HashMap<Integer, String[]>() {{
			put(51442, new String[] {"Denison", "Iowa"});
			put(90210, new String[] {"Beverly Hills", "California"});
			put(77904, new String[] {"Victoria", "Texas"});
			put(60652, new String[] {"Chicago", "Illinois"});
		}};
	
	private int mZipcode;
	public void setZipcode(int zipcode) { mZipcode = zipcode; }
	
	public void processElement()
	{
		String[] results = ZIPCODES.get(mZipcode);
		if (null == results)
		{
			results = new String[] {"unknown", "unknown"};
		}
		
		print("<zipcode-result>"+
			  "<city>"+results[0]+"</city>"+
			  "<state>"+results[1]+"</state>"+
			  "</zipcode-result>");
	}
}
